#include "skinlib.h"
AnsiString NScrollBar::NewName( AnsiString headStr ) {
	int i;
	AnsiString searchWord;
	for ( i = 1;i <= 64;i++ ) {
		searchWord = headStr + AnsiString( i );
		if ( ! myForm->FindComponent( searchWord ) ) {
			return searchWord;
		}
	}
	searchWord = "";
	return searchWord;
}
NScrollBar::NScrollBar( TForm *_myForm, TWinControl *_MainControl ) {
	myForm = _myForm ;
	MainControl = _MainControl;
	scrollPanel = new TPanel( myForm );
	maxButton = new TPanel( myForm );
	minButton = new TPanel( myForm );
	thumbButton = new TPanel( myForm );


	myTimer = new TTimer( myForm );
	myTimer->Enabled = false;
	myTimer->Interval = 90;
	myTimer->OnTimer = myTimerTimer;

	scrollPanel->Parent = myForm;

	maxButton->Parent = scrollPanel;
	minButton->Parent = scrollPanel;
	thumbButton->Parent = scrollPanel;
	::SetParent( scrollPanel->Handle , ::GetParent( MainControl->Handle ) );
	//			scrollPanel->BringToFront() ;

	scrollPanel->Name = NewName( "NScrollBarPanel" );
	minButton->Name = NewName( "NScrollBarMin" );
	maxButton->Name = NewName( "NScrollBarMax" );
	thumbButton->Name = NewName( "NScrollBarThumb" );



	scrollPanel->TabStop = false;
	maxButton->TabStop = false;
	minButton->TabStop = false;
	thumbButton->TabStop = false;



	setVertical();
	//        	setHorizontal();
	SmallChange = 1;
	LargeChange = 5;
	Min = 0;
	Max = 100;
	PageSize = 20;
	Position = 5;
	mouseIsDown = false;
	currentClick = 0;

	scrollPanel->Visible = true;

	init();

}
NScrollBar::~NScrollBar() {

	myTimer->Enabled = false;
	if ( maxButton != NULL )
		delete maxButton ;
	if ( minButton != NULL )
		delete minButton ;
	if ( thumbButton != NULL )
		delete thumbButton ;
	if ( myTimer != NULL ) {
		delete myTimer;
	}
	if ( scrollPanel != NULL )
		delete scrollPanel ;

}
void NScrollBar::setVertical() {
	Vertical = true;
	Horizontal = false;
}
void NScrollBar::setHorizontal() {
	Vertical = false;
	Horizontal = true;
}
bool NScrollBar::assignMainScrollPos() {

	if ( String( MainControl->ClassName() ) == "TScrollBar" ) {
		( ( TScrollBar * ) MainControl ) ->Position = Position;
	} else {
		memset( &sInfo, 0, sizeof( SCROLLINFO ) ); //cl
		sInfo.cbSize = sizeof( SCROLLINFO );
		sInfo.fMask = SIF_POS ;
		sInfo.nPos = Position ;
		if ( String( MainControl->ClassName() ) == "TScrollBar" ) {
			SetScrollInfo( MainControl->Handle , SB_CTL , &sInfo , TRUE ) ;
			SendMessage( MainControl->Handle , WM_VSCROLL , MAKEWPARAM( SB_THUMBPOSITION, Position ) , NULL );
		} else if ( Vertical ) {
			//					SetScrollInfo( MainControl->Handle , SB_VERT , &sInfo , TRUE ) ;

			if ( String( MainControl->ClassName() ) == "TListView" ) {
				//
				int oldPosition = Position;
				fetchMainScrollInfo();
				if ( currentClick == 1 )
					SendMessage( MainControl->Handle , LVM_SCROLL , 0 , -5 );
				else if ( currentClick == 2 )
					SendMessage( MainControl->Handle , LVM_SCROLL , 0 , 5 );
				else
					SendMessage( MainControl->Handle , LVM_SCROLL , 0 , oldPosition - Position );
				fetchMainScrollInfo();
			} else if ( String( MainControl->ClassName() ) == "TTreeView" ) {
				if ( currentClick == 3 )
					PostMessage( MainControl->Handle , WM_VSCROLL , MAKEWPARAM( SB_THUMBPOSITION, Position / 2 ) , NULL );
				else
					PostMessage( MainControl->Handle , WM_VSCROLL , MAKEWPARAM( SB_THUMBPOSITION, Position ) , NULL );

			} else
				PostMessage( MainControl->Handle , WM_VSCROLL , MAKEWPARAM( SB_THUMBPOSITION, Position ) , NULL );
			//						fetchMainScrollInfo();
			//					MainControl->Invalidate() ;
		} else {
			//					SetScrollInfo( MainControl->Handle , SB_HORZ , &sInfo , TRUE ) ;
			if ( String( MainControl->ClassName() ) == "TListView" ) {
				//
				int oldPosition = Position;
				fetchMainScrollInfo();
				if ( currentClick == 1 )
					SendMessage( MainControl->Handle , LVM_SCROLL , -5 , 0 );
				else if ( currentClick == 2 )
					SendMessage( MainControl->Handle , LVM_SCROLL , 5 , 0 );
				else
					SendMessage( MainControl->Handle , LVM_SCROLL , oldPosition - Position , 0 );
				//						fetchMainScrollInfo();
			} else
				PostMessage( MainControl->Handle , WM_HSCROLL , MAKEWPARAM( SB_THUMBPOSITION, Position ) , NULL );
		}
	}
}
bool NScrollBar::fetchMainScrollInfo() {
	int k;
	//			return false ;

	if ( String( MainControl->ClassName() ) == "TScrollBar" ) {
		scrollPanel->Left = MainControl->Left ;
		scrollPanel->Top = MainControl->Top ;
		scrollPanel->Height = MainControl->Height ;
		scrollPanel->Width = MainControl->Width ;
		Position = ( ( TScrollBar * ) MainControl ) ->Position ;
		if( ((TScrollBar *)MainControl)->PageSize!=0 )
			PageSize = ((TScrollBar *)MainControl)->PageSize ;
		else
        	PageSize=15;
		Min = ( ( TScrollBar * ) MainControl ) ->Min ;
		Max = ( ( TScrollBar * ) MainControl ) ->Max ;
		SmallChange = ( ( TScrollBar * ) MainControl ) ->SmallChange ;
		LargeChange = ( ( TScrollBar * ) MainControl ) ->LargeChange ;
		Left = ( ( TScrollBar * ) MainControl ) ->Left ;
		Top = ( ( TScrollBar * ) MainControl ) ->Top ;
		Width = ( ( TScrollBar * ) MainControl ) ->Width ;
		Height = ( ( TScrollBar * ) MainControl ) ->Height ;
		//
		//
		if ( Vertical ) {
			minButton->Top = 0;
			minButton->Left = 0;
			minButton->Width = scrollPanel->Width ;
			minButton->Height = 20;
			maxButton->Top = scrollPanel->Height - 20;
			maxButton->Width = scrollPanel->Width ;
			maxButton->Height = 20;
			maxButton->Left = 0;
			thumbButton->Left = 0;
			thumbButton->Width = scrollPanel->Width ;
			if ( thumbButton->Height != PageSize * ( scrollPanel->Height - maxButton->Height - minButton->Height ) / ( Max + PageSize - Min ) ) {
				k = PageSize * ( scrollPanel->Height - maxButton->Height - minButton->Height ) / ( Max + PageSize - Min ) ;
				if ( k < 20 && 0 ) {
					thumbButton->Height = 20;
				} else {
					thumbButton->Height = k;
				}
			}
			if ( thumbButton->Top != minButton->Top + minButton->Height + ( Position - Min ) * ( scrollPanel->Height - maxButton->Height - minButton->Height ) / ( Max + PageSize - Min ) ) {
				thumbButton->Top = minButton->Top + minButton->Height + ( Position - Min ) * ( scrollPanel->Height - maxButton->Height - minButton->Height ) / ( Max + PageSize - Min );
			}
			if ( thumbButton->Top + thumbButton->Height > maxButton->Top ) {
				thumbButton->Height = maxButton->Top - thumbButton->Top ;
			}
		} else {
			minButton->Height = scrollPanel->Height ;
			minButton->Width = 20;
			minButton->Top = 0;
			minButton->Left = 0;
			maxButton->Left = scrollPanel->Width - 20;
			maxButton->Height = scrollPanel->Height ;
			maxButton->Width = 20;
			maxButton->Top = 0;
			thumbButton->Top = 0;
			thumbButton->Height = scrollPanel->Height ;
			if ( thumbButton->Width != PageSize * ( scrollPanel->Width - maxButton->Width - minButton->Width ) / ( Max + PageSize - Min ) ) {
				k = PageSize * ( scrollPanel->Width - maxButton->Width - minButton->Width ) / ( Max + PageSize - Min ) ;

				if ( k < 20 && 0 ) {
					thumbButton->Width = 20;
				} else {
					thumbButton->Width = k;
				}
			}
			if ( thumbButton->Left != minButton->Left + minButton->Width + ( Position - Min ) * ( scrollPanel->Width - maxButton->Width - minButton->Width ) / ( Max + PageSize - Min ) )
				thumbButton->Left = minButton->Left + minButton->Width + ( Position - Min ) * ( scrollPanel->Width - maxButton->Width - minButton->Width ) / ( Max + PageSize - Min );
			if ( thumbButton->Left + thumbButton->Width > maxButton->Left ) {
				thumbButton->Width = maxButton->Left - thumbButton->Left ;
			}
		}
		//
	} else {
		SCROLLBARINFO sbInfo;
		memset( &sbInfo , 0 , sizeof( sbInfo ) );
		sbInfo.cbSize = sizeof( SCROLLBARINFO );
		if ( Vertical )
			k = GetScrollBarInfo( MainControl->Handle , OBJID_VSCROLL , &sbInfo );
		else
			k = GetScrollBarInfo( MainControl->Handle , OBJID_HSCROLL , &sbInfo );
		if ( !k ) {

			scrollPanel->Visible = false;
			//					ShowMessage("error");

			return false;
		}
		//				ShowMessage( sbInfo.rcScrollBar.left );
		//			if(!k) ShowMessage( SysErrorMessage( GetLastError() ));
		SCROLLINFO sInfo;
		memset( &sInfo , 0 , sizeof( sInfo ) );
		sInfo.cbSize = sizeof( SCROLLINFO );
		sInfo.fMask = SIF_ALL ;
		if ( Vertical )
			k = ( int ) GetScrollInfo( MainControl->Handle , SB_VERT , &sInfo );
		else
			k = ( int ) GetScrollInfo( MainControl->Handle , SB_HORZ , &sInfo );
		if ( !k ) {

			scrollPanel->Visible = false;
			//					ShowMessage("error");
			//					ShowMessage( sbInfo.rcScrollBar.left );
			//					ShowMessage( sbInfo.rcScrollBar.right - sbInfo.rcScrollBar.left );
			return false;
		}
		// ]pGk==1A٬OiSscrollbarsb
		// ɻݭn@@ƪ~q
		if ( Vertical ) {
			if ( ( sbInfo.rcScrollBar.right - sbInfo.rcScrollBar.left > MainControl->Width + 100 ) ||
			        ( sbInfo.rcScrollBar.bottom - sbInfo.rcScrollBar.top > MainControl->Height + 100 ) ) {
				//                     	ShowMessage("error1");
				scrollPanel->Visible = false;
				return false;
			}
		} else {
			if ( ( sbInfo.rcScrollBar.right - sbInfo.rcScrollBar.left > MainControl->Width + 100 ) ||
			        ( sbInfo.rcScrollBar.bottom - sbInfo.rcScrollBar.top > MainControl->Height + 100 )
			   ) {
				//                     	ShowMessage("error1");
				scrollPanel->Visible = false;
				return false;
			}
		}
		//ӥ`ScrollBar
		if ( scrollPanel->Visible == false )
			scrollPanel->Visible = true;

gogogo:
		;
		//	scrollPanel->Show() ;

		Position = sInfo.nPos ;
		Min = sInfo.nMin ;
		Max = sInfo.nMax ;
		TPoint myPt;
		myPt.x = sbInfo.rcScrollBar.left;
		myPt.y = sbInfo.rcScrollBar.top;
		myPt = MainControl->Parent->ScreenToClient( myPt );

		scrollPanel->Left = myPt.x ; //sbInfo.rcScrollBar.left;//- myForm->Left ;
		scrollPanel->Top = myPt.y ; //sbInfo.rcScrollBar.top - myForm->Top ;
		scrollPanel->Width = sbInfo.rcScrollBar.right - sbInfo.rcScrollBar.left ;
		scrollPanel->Height = sbInfo.rcScrollBar.bottom - sbInfo.rcScrollBar.top ;
		if ( Vertical ) {
			thumbButton->Top = sbInfo.xyThumbTop ;
			thumbButton->Height = sbInfo.xyThumbBottom - sbInfo.xyThumbTop ;
			thumbButton->Left = 0;
			thumbButton->Width = scrollPanel->Width ;
			maxButton->Top = scrollPanel->Height - 20;
			maxButton->Left = 0;
			minButton->Width = scrollPanel->Width ;
			maxButton->Width = scrollPanel->Width ;
			maxButton->Height = 20;
			minButton->Height = 20;
			minButton->Left = 0;
			minButton->Top = 0;
		} else {
			thumbButton->Left = sbInfo.xyThumbTop ;
			thumbButton->Width = sbInfo.xyThumbBottom - sbInfo.xyThumbTop ;
			thumbButton->Top = 0;
			thumbButton->Height = scrollPanel->Height ;
			maxButton->Left = scrollPanel->Width - 20;
			maxButton->Top = 0;
			maxButton->Height = scrollPanel->Height ;
			minButton->Height = scrollPanel->Height ;
			maxButton->Width = 20;
			minButton->Width = 20;
			minButton->Left = 0;
			minButton->Top = 0;

		}
	}
}
void __fastcall NScrollBar::myTimerTimer( TObject *Sender ) {
	if ( currentClick == 1 ) {
		minButtonOnClick();
	} else if ( currentClick == 2 ) {
		maxButtonOnClick();
	} else if ( currentClick == 0 ) {
		myTimer->Enabled = false;
	}
}

void __fastcall NScrollBar::maxButtonOnClick() {
	if ( Position + SmallChange <= Max ) {
		Position += SmallChange;
		//				minButton->Caption = AnsiString(Position);
	} else {
		Position = Max;
	}
	assignMainScrollPos();
	Refresh();
	if ( MainControl->Focused() == false ) {
		MainControl->SetFocus() ;
	}
}
void __fastcall NScrollBar::minButtonOnClick() {
	if ( Position - SmallChange >= Min ) {
		Position -= SmallChange;
		//				minButton->Caption = AnsiString(Position);
	} else {
		Position = Min;
	}
	assignMainScrollPos();
	Refresh();
	if ( MainControl->Focused() == false ) {
		MainControl->SetFocus() ;
	}
}
void __fastcall NScrollBar::minButtonMouseDown( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	currentClick = 1;
	myTimer->Enabled = true;
}
void __fastcall NScrollBar::minButtonMouseUp( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	currentClick = 0;
	myTimer->Enabled = false;
}
void __fastcall NScrollBar::maxButtonMouseDown( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	currentClick = 2;
	myTimer->Enabled = true;
}
void __fastcall NScrollBar::maxButtonMouseUp( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	currentClick = 0;
	myTimer->Enabled = false;
}
void __fastcall NScrollBar::thumbButtonMouseDown( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	if ( !mouseIsDown ) {
		mouseIsDown = true;
		sX = X;
		sY = Y;
		currentClick = 3;
		if ( Vertical )
			sP = thumbButton->Top ;
		else
			sP = thumbButton->Left ;

	}
}
void __fastcall NScrollBar::thumbButtonMouseUp( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	currentClick = 0;
	if ( mouseIsDown && Y != sY && X != sX ) {
		if ( Vertical ) {
			sP += ( Y - sY );
			Position = ( sP - minButton->Top - minButton->Height ) * ( Max + PageSize - Min ) / ( scrollPanel->Height - maxButton->Height - minButton->Height ) + Min ;
		} else {
			sP += ( X - sX );
			Position = ( sP - minButton->Left - minButton->Width ) * ( Max + PageSize - Min ) / ( scrollPanel->Width - maxButton->Width - minButton->Width ) + Min ;
		}
		if ( Position >= Max )
			Position = Max;
		if ( Position <= Min )
			Position = Min;
		//				maxButton->Caption = Position;//sP+(Y-sY)*(scrollPanel->Height-maxButton->Height -minButton->Height ) /(Max-Min);//(Y-sY);
		assignMainScrollPos();
		Refresh();
		if ( MainControl->Focused() == false ) {
			MainControl->SetFocus() ;
		}
	}
	mouseIsDown = false;
}
void __fastcall NScrollBar::thumbButtonMouseMove( TObject *Sender, TShiftState Shift,
        int X, int Y ) {

	if ( mouseIsDown ) {
		/*				if( String(MainControl->ClassName())=="TTreeView" )
							return;*/

		if ( Vertical ) {
			sP += ( Y - sY );
			Position = ( sP - minButton->Top - minButton->Height ) * ( Max + PageSize - Min ) / ( scrollPanel->Height - maxButton->Height - minButton->Height ) + Min ;
		} else {
			sP += ( X - sX );
			Position = ( sP - minButton->Left - minButton->Width ) * ( Max + PageSize - Min ) / ( scrollPanel->Width - maxButton->Width - minButton->Width ) + Min ;
		}
		if ( Position >= Max )
			Position = Max;
		if ( Position <= Min )
			Position = Min;
		//				maxButton->Caption = Position;//sP+(Y-sY)*(scrollPanel->Height-maxButton->Height -minButton->Height ) /(Max-Min);//(Y-sY);
		assignMainScrollPos();
		Refresh();
		if ( MainControl->Focused() == false ) {
			MainControl->SetFocus() ;
		}
	}
}
void __fastcall NScrollBar::scrollPanelMouseDown( TObject *Sender, TMouseButton Button,
        TShiftState Shift, int X, int Y ) {
	if ( Vertical ) {
		if ( Y > thumbButton->Top + thumbButton->Height ) {
			if ( Position + LargeChange <= Max ) {
				Position += LargeChange;
			} else {
				Position = Max;
			}
			assignMainScrollPos();
			Refresh();
			if ( MainControl->Focused() == false ) {
				MainControl->SetFocus() ;
			}
		} else if ( Y < thumbButton->Top ) {
			if ( Position - LargeChange >= Min ) {
				Position -= LargeChange;
			} else {
				Position = Min;
			}
			assignMainScrollPos();
			Refresh();
			if ( MainControl->Focused() == false ) {
				MainControl->SetFocus() ;
			}
		}
	} else {
		if ( X > thumbButton->Left + thumbButton->Width ) {
			if ( Position + LargeChange <= Max ) {
				Position += LargeChange;
			} else {
				Position = Max;
			}
			assignMainScrollPos();
			Refresh();
			if ( MainControl->Focused() == false ) {
				MainControl->SetFocus() ;
			}
		} else if ( X < thumbButton->Left ) {
			if ( Position - LargeChange >= Min ) {
				Position -= LargeChange;
			} else {
				Position = Min;
			}
			assignMainScrollPos();
			Refresh();
			if ( MainControl->Focused() == false ) {
				MainControl->SetFocus() ;
			}
		}

	}
}
/*		void __fastcall scrollPanelMouseUp(TObject *Sender, TMouseButton Button,
			  TShiftState Shift, int X, int Y)
		{
 
		}
		void __fastcall scrollPanelClick(TObject *Sender)
		{
 
		}*/
void NScrollBar::Refresh() {
	fetchMainScrollInfo();
}
void __fastcall NScrollBar::minButtonEnter( TObject *Sender ) {
	if ( MainControl->Visible ) {
		MainControl->SetFocus() ;
	}
}
void NScrollBar::init() {
	// վm
	// l
	scrollPanel->Left = 0;
	scrollPanel->Top = 0;
	scrollPanel->Width = 10;
	scrollPanel->Height = 10;
	minButton->Left = 0;
	minButton->Top = 0;
	minButton->Width = 5;
	minButton->Height = 5;
	maxButton->Left = 0;
	maxButton->Top = 0;
	maxButton->Width = 5;
	maxButton->Height = 5;
	thumbButton->Left = 0;
	thumbButton->Top = 0;
	thumbButton->Width = 5;
	thumbButton->Height = 5;

	if ( Vertical ) {
		scrollPanel->Tag = 0;
		scrollPanel->OnMouseDown = scrollPanelMouseDown;
		minButton->Tag = 0;
		maxButton->Tag = 0;
		maxButton->OnMouseDown = maxButtonMouseDown;
		maxButton->OnMouseUp = maxButtonMouseUp;
		minButton->OnMouseDown = minButtonMouseDown;
		minButton->OnMouseUp = minButtonMouseUp;
		thumbButton->Tag = 0;
		thumbButton->OnMouseDown = thumbButtonMouseDown;
		thumbButton->OnMouseMove = thumbButtonMouseMove;
		thumbButton->OnMouseUp = thumbButtonMouseUp;
		Refresh();
	} else {
		scrollPanel->Tag = 1;
		scrollPanel->OnMouseDown = scrollPanelMouseDown;
		minButton->Tag = 1;
		maxButton->Tag = 1;
		maxButton->OnMouseDown = maxButtonMouseDown;
		maxButton->OnMouseUp = maxButtonMouseUp;
		minButton->OnMouseDown = minButtonMouseDown;
		minButton->OnMouseUp = minButtonMouseUp;
		thumbButton->Tag = 1;
		thumbButton->OnMouseDown = thumbButtonMouseDown;
		thumbButton->OnMouseMove = thumbButtonMouseMove;
		thumbButton->OnMouseUp = thumbButtonMouseUp;
		Refresh();

	}
}

