#include "skinlib.h"
	#define NImageFormFrame 0
	#define MaxBmpFileLoad 12
NatureGraphicEngine::NatureGraphicEngine() {
	int i;
//	ThemeFileName = _ThemeFileName ;
	bmpArray = new Graphics::TBitmap * [ MaxBmpFileLoad ];
	for ( i = 0;i < MaxBmpFileLoad;i++ ) {
		bmpArray[ i ] = new Graphics::TBitmap;
	}
	LoadResourceImage();
}
NatureGraphicEngine::~NatureGraphicEngine() {
	int i;
	for ( i = 0;i < MaxBmpFileLoad;i++ ) {
		if ( bmpArray[ i ] != NULL )
			delete bmpArray[ i ] ;
	}
	delete[] bmpArray;
}
void NatureGraphicEngine::LoadResourceImage() {
	int i, j, k;
//	void * inst;
//	inst = ::LoadLibrary(ThemeFileName.c_str() );

	bmpArray[0]->LoadFromFile("Nimages\\Tbutton.bmp");
	bmpArray[1]->LoadFromFile("Nimages\\Tbitbtn.bmp");
	bmpArray[2]->LoadFromFile("Nimages\\Tradiobutton.bmp");
	bmpArray[3]->LoadFromFile("Nimages\\Tcheckbox.bmp");
	bmpArray[4]->LoadFromFile("Nimages\\Tcombobox.bmp");
	bmpArray[5]->LoadFromFile("Nimages\\TscrollbarHB.bmp");
	bmpArray[6]->LoadFromFile("Nimages\\TscrollbarHT.bmp");
	bmpArray[7]->LoadFromFile("Nimages\\TscrollbarVB.bmp");
	bmpArray[8]->LoadFromFile("Nimages\\TscrollbarVT.bmp");
	bmpArray[9]->LoadFromFile("Nimages\\TscrollbarBackground.bmp");	
//	ShowMessage("Images loaded successfully!");
//
//	::FreeLibrary( inst );
}

Graphics::TBitmap* NatureGraphicEngine::GetSubImage(int sx,int sy,int subWidth,int subHeight,Graphics::TBitmap *SrcBitmap,Graphics::TBitmap *DestBitmap)
{
	DestBitmap->Width=subWidth;
	DestBitmap->Height=subHeight;
	DestBitmap->Canvas->CopyRect(Rect(0,0,subWidth,subHeight),SrcBitmap->Canvas,Rect(sx*subWidth,sy*subHeight,(sx+1)*subWidth,(sy+1)*subHeight) );
	return DestBitmap;
}

void NatureGraphicEngine::FrameDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height ) {
	register int i, j, stepW,stepH;
	stepW = ( myBmp->Width ) / 3;
	stepH = ( myBmp->Height ) / 3;
	// eI

	for ( i = X; i <= X + Width; i += stepW ) {
		for ( j = Y;j <= Y + Height ;j += stepH ) {
			myCanvas->CopyRect( Rect( i, j, i + stepW , j + stepH ), myBmp->Canvas ,
								Rect( stepW , stepH , stepW + stepW , stepH + stepH ) );
		}
	}

	// eW
	for ( i = X; i <= X + Width ; i += stepW ) {
		myCanvas->CopyRect( Rect( i, Y, i + stepW , Y + stepH ), myBmp->Canvas ,
							Rect( stepW , 0 , stepW + stepW , 0 + stepH ) );
	}
	// eU
	for ( i = X; i <= X + Width ; i += stepW ) {
		myCanvas->CopyRect( Rect( i, Y + Height - stepH, i + stepW , Y + Height ), myBmp->Canvas ,
							Rect( stepW , stepH * 2 , stepW + stepW , stepH * 2 + stepH ) );
	}
	// e誺
	for ( i = Y;i <= Y + Height ;i += stepH ) {
		myCanvas->CopyRect( Rect( X, i, X + stepW, i + stepH ) , myBmp->Canvas , Rect( 0, stepH, 0 + stepW, stepH + stepH ) );
	}
	// ek誺
	for ( i = Y;i <= Y + Height ;i += stepH ) {
		myCanvas->CopyRect( Rect( X + Width - stepW, i, X + Width, i + stepH ) , myBmp->Canvas , Rect( stepW * 2, stepH, stepW * 2 + stepW, stepH + stepH ) );
	}
	// eW
	myCanvas->CopyRect( Rect( X, Y , X + stepW, Y + stepH ) , myBmp->Canvas , Rect( 0, 0, stepW, stepH ) );
	// eU
	myCanvas->CopyRect( Rect( X, Y + Height - stepH, stepW, Y + Height ) , myBmp->Canvas , Rect( 0, stepH * 2, stepW, stepH * 2 + stepH ) );
	// ekW
	myCanvas->CopyRect( Rect( X + Width - stepW, Y, X + Width, stepH ) , myBmp->Canvas , Rect( stepW * 2, 0, stepW * 2 + stepW, stepH ) );
	// ekU
	myCanvas->CopyRect( Rect( X + Width - stepW, Y + Height - stepH, X + Width, Y + Height ) , myBmp->Canvas , Rect( stepW * 2, stepH * 2, stepW * 2 + stepW, stepH * 2 + stepH ) );

}
void NatureGraphicEngine::StretchDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height ) {
	// eXiϧ
	myCanvas->CopyRect( Rect( X, Y, X + Width, Y + Height ), myBmp->Canvas, Rect( 0, 0, myBmp->Width, myBmp->Height ) );
}

void NatureGraphicEngine::ScrollBarDrawH( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height )
{
	int i, j;
	if( Width<=0 ||Height<=0 ) return;
	Graphics::TBitmap *tbmp=new Graphics::TBitmap;
	tbmp->Width = Width ;
	tbmp->Height = Height ;
	tbmp->PixelFormat = myBmp->PixelFormat ;
	for ( i = 0;i <=   Width ;i += myBmp->Width ) {
//		for ( j = 0;j <= Height ;j += myBmp->Height ) {
			tbmp->Canvas->CopyRect( Rect( i, 0, i + myBmp->Width , Height ), myBmp->Canvas, Rect( 0, 0, myBmp->Width, myBmp->Height ) );
//		}
	}
	tbmp->Width = Width ;
	tbmp->Height = Height ;

	BitBlt(myCanvas->Handle ,X,Y,Width,Height,tbmp->Canvas->Handle ,0,0,SRCCOPY);

	delete tbmp;
}

void NatureGraphicEngine::ScrollBarDrawV( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height )
{
	int i, j;
	if( Width<=0 ||Height<=0 ) return;
	Graphics::TBitmap *tbmp=new Graphics::TBitmap;
	tbmp->Width = Width ;
	tbmp->Height = Height ;
	tbmp->PixelFormat = myBmp->PixelFormat ;
//	for ( i = 0;i <=   Width ;i += myBmp->Width ) {
		for ( j = 0;j <= Height ;j += myBmp->Height ) {
			tbmp->Canvas->CopyRect( Rect( 0, j, Width , j + myBmp->Height ), myBmp->Canvas, Rect( 0, 0, myBmp->Width, myBmp->Height ) );
		}
//	}
	tbmp->Width = Width ;
	tbmp->Height = Height ;

	BitBlt(myCanvas->Handle ,X,Y,Width,Height,tbmp->Canvas->Handle ,0,0,SRCCOPY);

	delete tbmp;
}

void NatureGraphicEngine::AlongsideDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height ) {
	// eXñƪϧ
	int i, j;
	if( Width<=0 ||Height<=0 ) return;
	Graphics::TBitmap *tbmp=new Graphics::TBitmap;
	tbmp->Width = Width ;
	tbmp->Height = Height ;
	tbmp->PixelFormat = myBmp->PixelFormat ;
	for ( i = 0;i <=   Width ;i += myBmp->Width ) {
		for ( j = 0;j <= Height ;j += myBmp->Height ) {
			tbmp->Canvas->CopyRect( Rect( i, j, i + myBmp->Width , j + myBmp->Height ), myBmp->Canvas, Rect( 0, 0, myBmp->Width, myBmp->Height ) );
		}
	}
	tbmp->Width = Width ;
	tbmp->Height = Height ;

	BitBlt(myCanvas->Handle ,X,Y,Width,Height,tbmp->Canvas->Handle ,0,0,SRCCOPY);

	delete tbmp;
}
void NatureGraphicEngine::CenterDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height ) {
	// NmyBmpϧεebmyCanvas
	myCanvas->CopyRect( Rect( X + ( Width / 2 ) - ( myBmp->Width / 2 ) , Y + ( Height / 2 ) - ( myBmp->Height / 2 ) , X + ( Width / 2 ) - ( myBmp->Width / 2 ) + myBmp->Width , Y + ( Height / 2 ) - ( myBmp->Height / 2 ) + myBmp->Height ) ,
	                    myBmp->Canvas ,
	                    Rect( 0, 0, myBmp->Width, myBmp->Height ) );
}
void NatureGraphicEngine::Blur( Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height ) {
	return ;
	//		myBmp->PixelFormat = pf24bit;
	static Byte *ptrPrevious, *ptr, *ptrNext;
	register int R, G, B, x, y;
	int myHeight = Height, myWidth = Width;
	for ( y = Y + 1;y < Y + myHeight - 1 ;y++ ) {
		ptrPrevious = ( Byte* ) myBmp->ScanLine[ y - 1 ];
		ptr = ( Byte* ) myBmp->ScanLine[ y ];
		ptrNext = ( Byte* ) myBmp->ScanLine[ y + 1 ];
		for ( x = X + 1;x < X + myWidth - 1 ;x++ ) {
			R = ptrPrevious[ ( x - 1 ) * 3 + 2 ] + ptrPrevious[ x * 3 + 2 ] + ptrPrevious[ ( x + 1 ) * 3 + 2 ]
			    + ptr[ ( x - 1 ) * 3 + 2 ] + ptr[ x * 3 + 2 ] + ptr[ ( x + 1 ) * 3 + 2 ]
			    + ptrNext[ ( x - 1 ) * 3 + 2 ] + ptrNext[ x * 3 + 2 ] + ptrNext[ ( x + 1 ) * 3 + 2 ] ;
			G = ptrPrevious[ ( x - 1 ) * 3 + 1 ] + ptrPrevious[ x * 3 + 1 ] + ptrPrevious[ ( x + 1 ) * 3 + 1 ]
			    + ptr[ ( x - 1 ) * 3 + 1 ] + ptr[ x * 3 + 1 ] + ptr[ ( x + 1 ) * 3 + 1 ]
			    + ptrNext[ ( x - 1 ) * 3 + 1 ] + ptrNext[ x * 3 + 1 ] + ptrNext[ ( x + 1 ) * 3 + 1 ] ;
			B = ptrPrevious[ ( x - 1 ) * 3 ] + ptrPrevious[ x * 3 ] + ptrPrevious[ ( x + 1 ) * 3 ]
			    + ptr[ ( x - 1 ) * 3 ] + ptr[ x * 3 ] + ptr[ ( x + 1 ) * 3 ]
			    + ptrNext[ ( x - 1 ) * 3 ] + ptrNext[ x * 3 ] + ptrNext[ ( x + 1 ) * 3 ] ;
			ptr[ x * 3 + 2 ] = R / 9;
			ptr[ x * 3 + 1 ] = G / 9;
			ptr[ x * 3 ] = B / 9;
			/*				if( 255-(ptr[ x * 3 + 2 ]+ptr[ x * 3 + 1 ]+ptr[ x * 3 ])/3 < 30 ){
								ptr[ x * 3 + 2 ]=255;
								ptr[ x * 3 + 1 ]=255;
								ptr[ x * 3 ]=255;
							}*/

		}
	}
}
void NatureGraphicEngine::TextDraw( TCanvas *myCanvas, AnsiString &Caption, int X, int Y ) {
	//		Graphics::TBitmap *textBmp=new Graphics::TBitmap;
	RECT textArea;
	/*		textBmp->PixelFormat = pf24bit ;
			textBmp->Transparent = true;
			textBmp->TransparentColor = clWhite;
			textBmp->TransparentMode = tmAuto;
			textBmp->Width = myCanvas->TextWidth(Caption) + 4 ;
			textBmp->Height = myCanvas->TextHeight(Caption) + 4 ;
			textBmp->Canvas->Font->Assign(myCanvas->Font);
			textBmp->Canvas->Font->Color = FluorColor ;*/ 
	/*//		SetBkMode(myCanvas->Handle ,TRANSPARENT);*/
	textArea.left = X ;
	textArea.top = Y ;
	textArea.right = X + myCanvas->TextWidth( Caption ) + 1 ;
	textArea.bottom = Y + myCanvas->TextHeight( Caption ) + 1 ;
	DrawText( myCanvas->Handle , Caption.c_str() , Caption.Length() , &textArea , DT_TABSTOP );
	/*//		Blur( textBmp , 0 , 0 , textBmp->Width , textBmp->Height );
	//		textBmp->Canvas->Font->Color = myCanvas->Font->Color ;
	//		DrawText( textBmp->Canvas->Handle , Caption.c_str() , Caption.Length() , &textArea , DT_TABSTOP );
	//		myCanvas->CopyRect(Rect(X,Y,X+textBmp->Width,Y+textBmp->Height),textBmp->Canvas,Rect(0 , 0 , textBmp->Width , textBmp->Height) );
	//    	textBmp->Canvas->Brush->Style =bsClear;
			myCanvas->Draw(X,Y,textBmp);
			Blur( myCanvas , X , Y ,  , textBmp->Height );*/

	//		delete textBmp;
}
