/*
NatureSkin (V0.9) 2006 OpenSource Edition

Author: Liu,Jiun Jiue. In Taiwan NCTU 

Copyright (c) 2006  Liu,Jiun Jiue.

GPL License

Homepage: http://www.cs.nctu.edu.tw/~hank1985/opensource/natureskin/

*/
#ifndef _SkinLib
#define _SkinLib
#include <vcl.h>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <CheckLst.hpp>

#include <vector>
#include <cstring>
#define myMin(x,y) ((x)<(y)?(x):(y))

//#ifndef useThemeDLL
//	#pragma resource "NSkin.res"
//	#pragma resource "nskin2.res"
//#endif


#define MaxControlSkinAmount 148

void skinAlpha( Graphics::TBitmap *bkg , Graphics::TBitmap *foreg , int alpha ) ;
void skinBrightness( Graphics::TBitmap *Bmp, int posi ) ;
void RGBAClear( Graphics::TBitmap *Bmp );
//

class NShareObject;
class NatureSkin;

struct _StyleInfo {
	int LeftEdgeWidth, RightEdgeWidth, TopEdgeWidth, BottomEdgeWidth;
	int TitleButtonTop;
	int RoundCornerWidth;
	int CaptionLeft, CaptionTop;
	int EnableCaptionEdgeColor;
	unsigned int CaptionColor;
	unsigned int CaptionEdgeColor;
};


struct NThemeInfo {
	AnsiString ThemeName;
	AnsiString ThemeAuthor;
	AnsiString ThemeCopyright;
	_StyleInfo GlassStyleInfo, NoGlassStyleInfo;
};
struct NThemeSetting {
	bool GlassStyle;
	bool SkinTForm;
	bool SkinBackground;
	bool SkinTToolBar;
	bool SkinTButton;
	bool SkinTBitBtn;
	bool SkinTPageControl;
	bool SkinTPanel;
	bool SkinTRadioGroup;
	bool SkinTGroupBox;
	bool SkinTMemo;
	bool SkinTRadioButton;
	bool SkinTCheckBox;
	bool SkinTColorBox;
	bool SkinTComboBox;
	bool SkinTListBox;
	bool SkinTListView;
	bool SkinTTreeView;
	bool SkinTScrollBar;
	bool SkinTCheckListBox;
	bool SkinTStringGrid;
	bool SkinTDrawGrid;
};

//

class NatureGraphicEngine {
public:
	Graphics::TBitmap **bmpArray;
	AnsiString ThemeFileName;
	NatureGraphicEngine( );
	~NatureGraphicEngine();
	void LoadResourceImage();
	Graphics::TBitmap* GetSubImage(int sx,int sy,int subWidth,int subHeight,Graphics::TBitmap *SrcBitmap,Graphics::TBitmap *DestBitmap);
	void FrameDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height);
	void StretchDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height );
	void ScrollBarDrawH( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height );
	void ScrollBarDrawV( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height );
	void AlongsideDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height );
	void CenterDraw( TCanvas *myCanvas, Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height );
	void Blur( Graphics::TBitmap *myBmp, int X, int Y, int Width, int Height );
	void TextDraw( TCanvas *myCanvas, AnsiString &Caption, int X, int Y );
};


class NShareObject {
public:
	// Bxs󪺫СASإߥs
	NatureSkin *MainCore;
	NatureGraphicEngine *MainGE;
	
	NShareObject() {
    	;
	}
};
class NScrollBar {
private :
public:
	bool mouseIsDown;
	int sX, sY, sP;

	int Max, Min, SmallChange, LargeChange, PageSize;
	int Position;
	int Left, Top, Width, Height;
	bool Visible;
	TWinControl *MainControl;
	TTimer *myTimer;
	int currentClick;
	//
	TPanel *scrollPanel;
	TPanel *maxButton, *minButton, *thumbButton;
	TForm *myForm;
	bool Vertical, Horizontal;
	SCROLLINFO sInfo;
	//
	AnsiString NewName( AnsiString headStr );
	NScrollBar( TForm *_myForm, TWinControl *_MainControl );
	~NScrollBar();
	void setVertical();
	void setHorizontal();
	bool assignMainScrollPos();
	bool fetchMainScrollInfo();
	void __fastcall myTimerTimer( TObject *Sender );
	void __fastcall maxButtonOnClick();
	void __fastcall minButtonOnClick();
	void __fastcall minButtonMouseDown( TObject *Sender, TMouseButton Button,
	                                    TShiftState Shift, int X, int Y );
	void __fastcall minButtonMouseUp( TObject *Sender, TMouseButton Button,
	                                  TShiftState Shift, int X, int Y );
	void __fastcall maxButtonMouseDown( TObject *Sender, TMouseButton Button,
	                                    TShiftState Shift, int X, int Y );
	void __fastcall maxButtonMouseUp( TObject *Sender, TMouseButton Button,
	                                  TShiftState Shift, int X, int Y );
	void __fastcall thumbButtonMouseDown( TObject *Sender, TMouseButton Button,
	                                      TShiftState Shift, int X, int Y );
	void __fastcall thumbButtonMouseUp( TObject *Sender, TMouseButton Button,
	                                    TShiftState Shift, int X, int Y );

	void __fastcall thumbButtonMouseMove( TObject *Sender, TShiftState Shift,
	                                      int X, int Y );
	void __fastcall scrollPanelMouseDown( TObject *Sender, TMouseButton Button,
	                                      TShiftState Shift, int X, int Y );
	void Refresh();
	void __fastcall minButtonEnter( TObject *Sender );
	void init();
};


//-----------------------------------------------
class TControlSubClass: public Classes::TComponent {
public:
	unsigned int myHandle;
	NShareObject *myShare;
	Classes::TWndMethod orgWindowProc;
	Graphics::TBitmap *SkinImage, *resourceImage[ 3 ],*bmpBuffer;
	Graphics::TBitmap *formBackground;
	// HUзǤ
	TButton *tbuttonPtr;
	TBitBtn *tbitbtnPtr;
	TRadioButton *tradiobuttonPtr;
	TCheckBox *tcheckboxPtr;
	TComboBox *tcomboboxPtr;
	TColorBox *tcolorboxPtr;
	TPanel *tpanelPtr;
	TPageControl *tpagecontrolPtr;
	TMemo *tmemoPtr;
	TStringGrid *tstringgridPtr;
	TListBox *tlistboxPtr;
	TTreeView *ttreeviewPtr;
	TListView *tlistviewPtr;
	TCheckListBox *tchecklistboxPtr;
	TDrawGrid *tdrawgridPtr;
	TRadioGroup *tradiogroupPtr;
	TGroupBox *tgroupboxPtr;
	TScrollBar *tscrollbarPtr;

	//
	NScrollBar *nscrollbar;
	NScrollBar *nscrollbar2;
	//
	TTimer *tbuttonTimer;
	TTimer *tbitbtnTimer;
	//
	//
	TBitBtn *pageButton[ 64 ];
	struct myPageStruct {
		TRect myRect;
		bool exist;
		bool drawself;
	};
	myPageStruct pageRect[ 64 ];
	void __fastcall pageButtonMouseDown( TObject *Sender,
	                                     TMouseButton Button, TShiftState Shift, int X, int Y );
	int alphaValue;
	void __fastcall tbuttonOnTimer( TObject *Sender ) {
		return;
		alphaValue -= 65;
		if ( alphaValue < 65 ) {
			tbuttonTimer->Enabled = false ;
			alphaValue = 0;
		}
		if ( mmove )
			DrawButton( 1, 0 );
		else if ( mdown )
			DrawButton( 2, 0 );
		else
			DrawButton( 0, 0 );
	}
	void __fastcall tbitbtnOnTimer( TObject *Sender ) {
    	return;
		alphaValue -= 65;
		if ( alphaValue < 65 ) {
			tbitbtnTimer->Enabled = false ;
			alphaValue = 0;
		}
		if ( mmove )
			DrawBitBtn( 1, 0 );
		else if ( mdown )
			DrawBitBtn( 2, 0 );
		else
			DrawBitBtn( 0, 0 );
	}
	// ------------------------
	AnsiString ControlType;
	int Style;
	bool mdown, mmove, getfocus; //sA
	TForm *myForm;
	bool freeze;
	void DrawBackgroundImage( TControl* Control, TCanvas* DestCanvas );
	void __fastcall DrawPageControl( int buttonState, int extra );
	void __fastcall PageControlDrawTab( TCustomTabControl *Control,
	                                    int TabIndex, const TRect &Rect, bool Active );
	void __fastcall DrawRadioButton( int buttonState, int extra );
	void __fastcall DrawCheckBox( int buttonState, int extra );
	void __fastcall DrawComboBox( int buttonState, int extra );
	void __fastcall DrawColorBox( int buttonState, int extra );
	void __fastcall DrawPanel( int buttonState, int extra );
	void __fastcall DrawButton( int buttonState, int extra );
	void __fastcall DrawBitBtn( int buttonState, int extra );
	void __fastcall DrawScrollBar( int buttonState, int extra );
	void __fastcall DrawMemo( int buttonState, int extra );
	void __fastcall DrawStringGrid( int buttonState, int extra );
	void __fastcall DrawListBox( int buttonState, int extra );
	void __fastcall DrawTreeView( int buttonState, int extra );
	void __fastcall DrawListView( int buttonState, int extra );
	void __fastcall DrawCheckListBox( int buttonState, int extra );
	void __fastcall DrawDrawGrid( int buttonState, int extra );
	void __fastcall DrawRadioGroup( int buttonState, int extra );
	void __fastcall DrawGroupBox( int buttonState, int extra );
	//
	void __fastcall TPageControlMsg( unsigned int Msg );
	void __fastcall TButtonMsg( unsigned int Msg );
	void __fastcall TBitBtnMsg( unsigned int Msg );
	void __fastcall TRadioButtonMsg( unsigned int Msg );
	void __fastcall TCheckBoxMsg( unsigned int Msg );
	void __fastcall TComboBoxMsg( unsigned int Msg );
	void __fastcall TColorBoxMsg( unsigned int Msg );
	void __fastcall TPanelMsg( unsigned int Msg );
	void __fastcall TScrollBarMsg( unsigned int Msg );
	void __fastcall TMemoMsg( unsigned int Msg );
	void __fastcall TStringGridMsg( unsigned int Msg );
	void __fastcall TListBoxMsg( unsigned int Msg );
	void __fastcall TTreeViewMsg( unsigned int Msg );
	void __fastcall TListViewMsg( unsigned int Msg );
	void __fastcall TCheckListBoxMsg( unsigned int Msg );
	void __fastcall TDrawGridMsg( unsigned int Msg );
	void __fastcall TRadioGroupMsg( unsigned int Msg );
	void __fastcall TGroupBoxMsg( unsigned int Msg );
	void __fastcall ControlSubClass( Messages::TMessage &Message );
	__fastcall TControlSubClass( TForm *AOwner );
	__fastcall ~TControlSubClass( void );
	void __fastcall loadResourceImage();
	void __fastcall initCanvas();
	void __fastcall ReplaceWProc( Classes::TWndMethod &oldProc );
	void __fastcall RestoreWProc( Classes::TWndMethod &newProc );
};

//---------------------------------------------------------------------


//---------------------------------------------------------------------

class NatureSkin {
private:
	TControlSubClass *myControl[ MaxControlSkinAmount ];
	TForm *myForm;
	NShareObject *myShare;
	int controlCount;
	bool isActived;
	AnsiString ThemeFileName;
	NatureGraphicEngine *naGE;

	Classes::TWndMethod orgFormProc;
	void __fastcall FormSubClass( Messages::TMessage &Message );
	bool __fastcall AlreadySkin( unsigned int _Handle );
	bool __fastcall SkinControls();
	int __fastcall ReadResInteger(void *_instance,int _id);
	AnsiString __fastcall ReadResString(void *_instance,int _id);
public:
	NatureSkin( TForm *Owner );
	~NatureSkin();
	NThemeInfo ThemeInfo;
	NThemeSetting ThemeSetting;
	void __fastcall FreeControls();
	void __fastcall Inactive();
	void __fastcall Active();
	void __fastcall RefreshTitleButtons();
	void __fastcall MakeBackground();
	void __fastcall About();
	Graphics::TBitmap* __fastcall GetSkinBitmap(int Index);
};


#endif
